import logging
import random
import re

from telethon import events

from bot_s3rius.config import config
from bot_s3rius.utils.responses import check_if_only_smiles, danger_message, mark_unread

logger = logging.getLogger(__name__)


@config.telegram_client.on(events.ChatAction())
@danger_message
@mark_unread
async def welcome(event: events.ChatAction.Event):
    if event.user_joined:
        await event.respond(
            random.choice(
                ["Привет!", "Добро пожаловать!", "Здравствуй!", "Добрый день!"]
            )
        )
    if event.user_left or event.user_kicked:
        await event.respond(
            random.choice(["До скорых встреч!", "Прощайте!", "До свидания!", "Пока!"])
        )


@config.telegram_client.on(
    events.NewMessage(
        pattern=re.compile(r"^[Пп]ривет\.?", re.IGNORECASE),
        forwards=False,
        outgoing=False,
    )
)
@danger_message
@mark_unread
async def hello(event: events.ChatAction.Event):
    await event.respond(
        random.choice(["Здравствуйте!", "Добрый день!", "Приветствую.", "Привет!"])
    )


@config.telegram_client.on(
    events.NewMessage(pattern=check_if_only_smiles, outgoing=False)
)
@danger_message
@mark_unread
async def smile(event: events.NewMessage.Event):
    await event.respond(event.message.message)


@config.telegram_client.on(
    events.NewMessage(
        pattern=re.compile(r"^[Зз]дарова\s+(,\s*)?ебать\.?$", re.IGNORECASE),
        outgoing=False,
        forwards=False,
    )
)
@danger_message
@mark_unread
async def hello_fucker(event: events.NewMessage.Event):
    await event.respond(
        random.choice(
            [
                "Чего тебе, дружок?",
                "И что ты хотел?",
                "Ну, здравствуй.",
                "И вам не хворать.",
            ]
        )
    )
