class Rotor:
    """
    Class for text rotation. E.G.
    abcd
    bcda
    cdab
    ...
    """

    def __init__(self, original, start):
        self.original = original
        self.start = start
        self.rotation = original + " "

    @property
    def next_rotation(self):
        first = self.rotation[0]
        self.rotation = self.rotation[1:] + first
        return self.rotation[:-1]


def replace_by_index(base, replacement, index):
    if index < 0:  # add it to the beginning
        return replacement + base
    if index > len(base):  # add it to the end
        return base + replacement
    replacement_len = len(replacement)
    # insert the new string between "slices" of the original
    return base[:index] + replacement + base[index + replacement_len :]
