from unittest.mock import MagicMock

import pytest


class NewMessageTestEvent(object):
    def __init__(self, message: str, forwarded=False):
        self._msg = message
        self._fwd = forwarded
        self._res = None

    async def reply(self, response):
        self._res = response

    async def respond(self, response):
        self._res = response

    @property
    def pattern_match(self):
        mock = MagicMock()
        mock.group = MagicMock(return_value=self._msg)
        return mock

    @property
    def result(self):
        return self._res

    @property
    def message(self):
        message = MagicMock()
        message.message = self._msg
        return message

    @property
    def chat(self):
        chat = MagicMock()
        chat.id = "123123123"
        return chat

    async def get_chat(self):
        return MagicMock()


@pytest.fixture
def patch_mark_dialogue_unread():
    import telethon

    telethon.functions.messages.MarkDialogUnreadRequest = MagicMock(returning=True)
